;**************************************************************************
;*
;* FILE  dtv2_kernal.asm
;* Copyright (c) 2005, 2006 Daniel Kahlin <daniel@kahlin.net>
;* Written by Daniel Kahlin <daniel@kahlin.net>
;* $Id: dtv2_kernal.asm,v 1.1 2006-01-08 16:14:12 tlr Exp $
;*
;* DESCRIPTION
;*   This file contains the differences between a the original revision 3
;*   c64 kernal and the DTV V2 kernal.
;*
;* This information is valid for a DTV V2, batch "051005", ; 
;* flash image "2005 06 07 03:21:11" (stated at the bottom of the
;*  directory listing).
;*
;******
	processor 6502

	MAC	sac
	dc.b	$32,{1}
	ENDM
	MAC	sir
	dc.b	$42,{1}
	ENDM
	MAC	bra
	dc.b	$12,{1}-2-.
	ENDM

	include	patch.i


;**************************************************************************
;*
;* Configuration
;*
;******

; start of the patch
	PATCHHEADER
	

;**************************************************************************
;*
;* Display reset hooks.
;*
;******
;Kernal CINT (Initialize Screen and Keyboard)
;E518 20 A0 E5   JSR $E5A0
	STARTPATCH $e518,$e51a,$ff
	jsr	lf736
	ENDPATCH

;E59A 20 A0 E5   JSR $E5A0
	STARTPATCH $e59a,$e59c,$ff
	jsr	lf736
	ENDPATCH

	
;**************************************************************************
;*
;* Main patch
;*
;******
 	STARTPATCH $f72c,$fa65,$ff
lf72c:
	rts
lf72d:
	jmp	lf8f1
lf730:
	jmp	lf73c
lf733:
	jmp	lf9fd
lf736:
	jmp	lfa1d
lf739:
	jmp	lfa40
lf73c:
	sta	$93
	lda	$ba
	cmp	#$1
	beq	lf747
lf744:
	jmp	$f4a7
lf747:
	php
	sei
	lda	#$0
	sta	$93
	ldx	#$1
	stx	$d03f
	sta	$d307
	sta	$d309
	stx	$d306
	stx	$d308
	jsr	lf84d
	ldx	#$0
	stx	$f8
	stx	$f9
	stx	$fd
	inx
lf76a:
	stx	$fa
	lda	#$0
	sta	$fb
	lda	#$1
	sta	$fc
	jsr	$f5af
lf777:
	jsr	lf8b3
	jsr	lf8c3
	lda	#$20
	jsr	lf879
	lda	$100
	bne	lf78e
lf787:
	jsr	lf84d
	plp
	jmp	$f704
lf78e:
	lda	$b7
	bne	lf799
lf792:
	jsr	lf84d
	plp
	jmp	$f710
lf799:
	cmp	#$18
	bcc	lf79f
lf79d:
	bcs	lf787
lf79f:
	ldy	#$0
lf7a1:
	lda	($bb),y
	cmp	#$2a
	beq	lf7b6
lf7a7:
	cmp	$100,y
	bne	lf7e1
lf7ac:
	iny
	cpy	$b7
	bne	lf7a1
lf7b1:
	lda	$100,y
	bne	lf7e1
lf7b6:
	jsr	$f5d2
	ldx	#$5
lf7bb:
	lda	$118,x
	sta	$f8,x
	dex
	bpl	lf7bb
lf7c3:
	lda	$b9
	bne	lf7cf
lf7c7:
	lda	$c3
	sta	$fb
	lda	$c4
	sta	$fc
lf7cf:
	jsr	lf7e9
	jsr	lf84d
	lda	#$0
	sta	$d03f
	plp
	lda	#$0
	sta	$90
	clc
	rts
lf7e1:
	lda	#$20
	jsr	lf8d5
	jmp	lf777
lf7e9:
	lda	#$fe
	jsr	lf8a5
	jsr	lf8b3
	jsr	lf888
	lda	$fe
	beq	lf844
lf7f8:
	bmi	lf80c
lf7fa:
	tax
	jsr	lf8c3
	jsr	lf8b3
	txa
	jsr	lf893
	txa
	jsr	lf8e3
	jmp	lf7e9
lf80c:
	eor	#$80
	sta	$f7
	lda	#$1
	jsr	lf8d5
	ldx	$fd
lf817:
	ldy	$fc
	bne	lf81c
lf81b:
	dex
lf81c:
	dey
	lda	$fb
	clc
	adc	$ff
	bcc	lf828
lf824:
	iny
	bne	lf828
lf827:
	inx
lf828:
	sta	$d300
	sty	$d301
	txa
	ora	#$40
	sta	$d302
	jsr	lf8c3
	lda	$f7
	jsr	lf879
	lda	$f7
	jsr	lf8e3
lf841:
	jmp	lf7e9
lf844:
	ldx	$fb
	stx	$ae
	ldy	$fc
lf84a:
	sty	$af
	rts
lf84d:
	lda	#$0
	ldy	#$40
	sty	$d305
	iny
	sty	$d302
	sta	$d30b
	sta	$d304
	lda	#$10
	sta	$d301
	lda	#$f7
	sta	$d300
	sta	$d303
	lda	#$39
	sta	$d30a
	lda	#$f
	sta	$d31f
	jmp	lf881
	rts
lf879:
	jsr	lf89c
	lda	#$d
	sta	$d31f
lf881:
	lda	$d31f
	lsr
	bcs	lf881
lf887:
	rts
lf888:
	lda	#$2
	jsr	lf879
	lda	#$1
	jsr	lf8d5
	rts
lf893:
	pha
	jsr	lf879
	pla
	jsr	lf8d5
	rts
lf89c:
	sta	$d30a
	lda	#$0
	sta	$d30b
	rts
lf8a5:
	sta	$d303
	lda	#$0
	sta	$d304
	lda	#$40
	sta	$d305
	rts
lf8b3:
	lda	$f8
	sta	$d300
	lda	$f9
	sta	$d301
	lda	$fa
	sta	$d302
	rts
lf8c3:
	lda	$fb
	sta	$d303
	lda	$fc
	sta	$d304
	lda	$fd
	ora	#$40
	sta	$d305
	rts
lf8d5:
	clc
	adc	$f8
	sta	$f8
	bcc	lf8e2
lf8dc:
	inc	$f9
	bne	lf8e2
lf8e0:
	inc	$fa
lf8e2:
	rts
lf8e3:
	clc
	adc	$fb
	sta	$fb
	bcc	lf8f0
lf8ea:
	inc	$fc
	bne	lf8f0
lf8ee:
	inc	$fd
lf8f0:
	rts
lf8f1:
	ldx	#$ff
	sei
	txs
	cld
	lda	#$ff
	sta	$dc00
	lda	$dc00
	and	#$10
	bne	lf91e
lf902:
	sac	$ee
	lda	#$6
	sac	$00
	ldx	#$4
lf90a:
	lda	lfa18,x
	cmp	$8004,x
	bne	lf918
lf912:
	dex
	bpl	lf90a
lf915:
	jmp	($8000)
lf918:
	sac	$ee
	lda	#$2
	sac	$00
lf91e:
	ldx	#$0
	stx	$d020
	stx	$d011
	jsr	$fda3
	jsr	$fd50
	jsr	$fd15
	jsr	$e453
	jsr	$e3bf
lf935:
	lda	$d011
	bpl	lf935
lf93a:
	lda	$d011
	bmi	lf93a
lf93f:
	jsr	$e5a0
	lda	#$0
	sta	$d020
	sta	$d011
	jsr	$e51b
	jsr	$ff5e
	cli
	ldx	#$1
	stx	$d03f
	lda	#$0
	sta	$dd03
	lda	$dd01
	sta	$aa
	and	#$3
	sta	$d040
	lda	$aa
	lsr
	lsr
	and	#$f
	sta	$d04f
	bit	$aa
	bvs	lf975
lf972:
	lda	#$07
	dc.b	$2c
lf975:
	lda	#$06
	sta	$d04e
	bit	$aa
	bmi	lf981
lf97e:
	ldy	#$2
	dc.b	$2c
lf981:
	ldy	#$5
	lda	$1
	and	#$10
	bne	lf993
lf989:
	tya
	clc
	adc	#$6
	tay
	lda	#$0
	sta	$d04e
lf993:
	ldx	#$2
lf995:
	lda	lfa0c,y
	sta	$d041,x
	dey
	dex
	bpl	lf995
lf99f:
	lda	#$0
	sta	$d03f
	sei
	lda	#$7f
	sta	$dc00
	lda	$dc01
	and	#$4
	bne	lf9c4
lf9b1:
	cli
	lda	#$e
	sta	$d020
	lda	#$6
	sta	$d021
	lda	#$1b
	sta	$d011
	jmp	($a000)
lf9c4:
	ldx	#$fb
	txs
lf9c7:
	lda	#$8
	tay
	ldx	#$1
	jsr	$ffba
	lda	lf9fa
	ldx	#<lf9f5
	ldy	#>lf9f5
	jsr	$ffbd
	lda	#$0
	jsr	$ffd5
	stx	$2d
	sty	$2e
	lda	#$93
	sta	$dd00
	lda	#$15
	sta	$d018
	cli
	lda	#$b
	sta	$d011
	jmp	(lf9fb)
lf9f5:
	dc.b	"INTRO"
lf9fa:
	dc.b	lf9fa-lf9f5
lf9fb:
	dc.w	$080d
lf9fd:
	lda	$ba
	cmp	#$1
	beq	lfa06
lfa03:
	jmp	$f5ed
lfa06:
	lda	#$00
	sta	$90
	clc
	rts
lfa0c:
	dc.b	$1c,$13,$2a
	dc.b	$24,$31,$5b
	dc.b	$1c,$00,$00
	dc.b	$24,$00,$00
lfa18:
	dc.b	$c4,$d4,$d6,$38,$30 ; "DTV80"
lfa1d:
	lda	#$01
	sta	$d03f
	ldx	#$7
	lda	#$0
lfa26:
	sta	$d036,x
	sta	$d045,x
	dex
	bpl	lfa26
lfa2f:
	sta	$d04d
	lda	#$76
	sta	$d036
	sta	$d03a
	jsr	lfa40
	jmp	$e5a0
lfa40:
	lda	#$1
	sta	$d03f
	ldx	#$f
lfa47:
	lda	lfa56,x
	sta	$d200,x
	dex
	bpl	lfa47
lfa50:
	lda	#$0
	sta	$d03f
	rts
lfa56:
	dc.b	$00,$0f,$36,$be,$58,$db,$86,$ff
	dc.b	$29,$26,$3b,$05,$07,$df,$9a,$0a
	ENDPATCH	

;**************************************************************************
;*
;* Reset routine hook.
;*
;******
;FCE2 A2 FF      LDX #$FF
;FCE4 78         SEI
	STARTPATCH $fce2,$fce4,$ff
	jmp	lf72d
	ENDPATCH

	
;**************************************************************************
;*
;* Load and save vectors.
;*
;******
; FD4C A5 F4
; FD4E ED F5
	STARTPATCH $fd4c,$fd4f,$ff
	dc.w	lf730
	dc.w	lf733
	ENDPATCH

; end of the patch file
	PATCHFOOTER
; eof
