;**************************************************************************
;*
;* FILE  tlr_kernal.asm
;* Copyright (c) 2005, 2006, 2007 Daniel Kahlin <daniel@kahlin.net>
;* Written by Daniel Kahlin <daniel@kahlin.net>
;* $Id: tlr_kernal.asm,v 1.12 2007-06-24 19:27:40 tlr Exp $
;*
;* DESCRIPTION
;*   This file contains various patches to be applied upon the DTV kernal.
;*
;******
	processor 6502

	MAC	sac
	dc.b	$32,{1}
	ENDM
	MAC	sir
	dc.b	$42,{1}
	ENDM
	MAC	bra
	dc.b	$12,{1}-2-.
	ENDM

	include	patch.i


;**************************************************************************
;*
;* Configuration
;*
;******

; start of the patch
	PATCHHEADER

	IFCONST	MAIN_PATCH
;**************************************************************************
;*
;* Directory entry check hook
;*
;******
;F782 AD 00 01   LDA $0100
	STARTPATCH $f782,$f784,$ff
	jmp	dir_patch
	ENDPATCH

	ENDIF	;MAIN_PATCH


	IFCONST	LOAD_PATCH
;**************************************************************************
;*
;* Load patch
;*
;******
;F84D A9 00      LDA #$00
;F84F A0 40      LDY #$40
;F851 8C 05 D3   STY $D305
;F854 C8         INY
;F855 8C 02 D3   STY $D302
;F858 8D 0B D3   STA $D30B
;F85B 8D 04 D3   STA $D304
;F85E A9 10      LDA #$10
;F860 8D 01 D3   STA $D301
;F863 A9 F7      LDA #$F7
;F865 8D 00 D3   STA $D300
;F868 8D 03 D3   STA $D303
;F86B A9 39      LDA #$39
;F86D 8D 0A D3   STA $D30A
;F870 A9 0F      LDA #$0F
;F872 8D 1F D3   STA $D31F
;F875 4C 81 F8   JMP $F881
;F878 60         RTS
 	STARTPATCH $f84d,$f878,$ff
	lda	#$40
	sta	$d305
	lda	#$41
	sta	$d302
	lda	#$00
	sta	$d30b
	sta	$d304
	lda	#$10
	sta	$d301
	lda	#$f7
	sta	$d300
	sta	$d303
	lda	#$39
	sta	$d30a
	lda	#$0f
	bra	$f87e

	dc.b	"TLR"
	dc.b	$ff	; version
	ENDPATCH
		
	ENDIF ; LOAD_PATCH
		
	IFCONST	MAIN_PATCH
	IFCONST	HUMMER
;**************************************************************************
;*
;* Left button check
;*
;******
;F8F6 A9 FF      LDA #$FF
;F8F8 8D 00 DC   STA $DC00
;F8FB AD 00 01   LDA $DC00
;F8FE 29 10      AND #$10 
	STARTPATCH $f8f6,$f8ff,$ff
	lda	#$ff
	sta	$dc01
	lda	$dc01
	and	#%00000001	;JoyB0
	ENDPATCH

	ENDIF	;HUMMER
	ENDIF	;MAIN_PATCH
	
	IFCONST	HARD_VIDEO
;**************************************************************************
;*
;* Hard code video
;*
;******
;F951 A2 01      LDX #$01
;F953 8E 3F D0   STX $D03F
;F956 A9 00      LDA #$00
;F958 8D 03 DD   STA $DD03
;F95B AD 01 DD   LDA $DD01	;patch from here--->
;F95E 85 AA      STA $AA
;F960 29 03      AND #$03
;F962 8D 40 D0   STA $D040
;F965 A5 AA      LDA $AA
;F967 4A         LSR A
;F968 4A         LSR A
;F969 29 0F      AND #$0F
;F96B 8D 4F D0   STA $D04F
;F96E 24 AA      BIT $AA
;F970 70 03      BVS $F975
;F972 A9 07      LDA #$07
;F974 2C         .BYTE $2C
;F975 A9 06      LDA #$06
;F977 8D 4E D0   STA $D04E
;F97A 24 AA      BIT $AA
;F97C 30 03      BMI $F981
;F97E A0 02      LDY #$02
;F980 2C         .BYTE $2C
;F981 A0 05      LDY #$05
;F983 A5 01      LDA $01
;F985 29 10      AND #$10
;F987 D0 0A      BNE $F993
;F989 98         TYA
;F98A 18         CLC
;F98B 69 06      ADC #$06
;F98D A8         TAY
;F98E A9 00      LDA #$00
;F990 8D 4E D0   STA $D04E
;F993 A2 02      LDX #$02
;F995 B9 0C FA   LDA $FA0C,Y
;F998 9D 41 D0   STA $D041,X
;F99B 88         DEY
;F99C CA         DEX
;F99D 10 F6      BPL $F995	;<--- to here.
;F99F A9 00      LDA #$00
;F9A1 8D 3F D0   STA $D03F
	STARTPATCH $f95b,$f99e,$ea
	lda	#$00
	sta	$d040
	lda	#$00
	sta	$d041
	lda	#$00
	sta	$d042
	lda	#$00
	sta	$d043
	lda	#$00
	sta	$d04e
	lda	#$00
	sta	$d04f
	ENDPATCH

	ENDIF	;HARD_VIDEO
	
	
	IFCONST	SOFT_BOOT
;**************************************************************************
;*
;* auto-load "DTVMENU" instead of "INTRO"
;*
;******
;F9F5 49 4E 54 52 4F 05 0D 08 INTRO...
	STARTPATCH $f9f5,$f9fc,$ff
	dc.b	"DTVM*"
	dc.b	5
	dc.w	$080d
	ENDPATCH
	ENDIF	;SOFT_BOOT

	IFCONST	PALETTE_PATCH	
;**************************************************************************
;*
;* Palette patch.
;*
;******
;FA56 00 0F 36 BE 58 DB 86 FF	;Default Palette
;FA5E 29 26 3B 05 07 DF 9A 0A
	STARTPATCH $fa56,$fa65,$ff
	dc.b	$00,$0F,$35,$BC,$67,$E9,$84,$1E	; Palette zee
	dc.b	$27,$14,$39,$05,$09,$EE,$89,$0C
	ENDPATCH
	ENDIF	;PALETTE_PATCH
	
	IFCONST	MAIN_PATCH
;**************************************************************************
;*
;* Main patch
;*
;******
 	STARTPATCH $fa66,$fa9f,$ff
dir_patch:
	lda	$0100	;patch to use $ff as endmarker in the directory,
			;file-names starting with $00 in the dir are
			;skipped.
	cmp	#$ff	;this way the directory doesn't have to be
			;erased to add new files :)
dp_ex1:
	jmp	$f785

new_reset:
	ldx	#$ff
	sei
	txs
	cld
	stx	$dc00
	lda	$dc00	;read joystick
	IFNCONST HUMMER
	and	#%00000010	;Joystick down. (DTV)
	beq	nr_ex1	;skip to normal reset if joystick is pulled down
	ELSE
	and	#%00000001	;JoyA0 (Hummer)
	beq	nr_ex1	;skip to normal reset if JoyA0 is grounded.
	ENDIF
	sir	$e8
	ldy	#$7e	;map $1f8000 -> $8000
;	ldy	#$fe	;map $3f8000 ($1f8000) -> $8000
	ldx	#%01000101 ;from flash 
	sir	$12
	ldx	#4
nr_lp1:
	lda	$fa18,x	;check if "DTV80" at $1f8004
	cmp	$8004,x
	bne	nr_skp1	;no, reset mapping and exit
	dex
	bpl	nr_lp1
	jmp	($8000)	;Yes, run it!
nr_skp1:
	sir	$e8
	ldy	#$02	;map $008000 -> $8000
	ldx	#%01010101 ;in ram
	sir	$12
nr_ex1:
	IFNCONST HUMMER
	jmp	$f8fb	;go to normal reset (DTV)
	ELSE
	jmp	$f8f6	;go to normal reset (Hummer)
	ENDIF
	ENDPATCH	
	
;**************************************************************************
;*
;* Reset routine hook.
;*
;******
;FCE2 4C 2D F7   JMP $F72D
	STARTPATCH $fce2,$fce4,$ff
	jmp	new_reset
	ENDPATCH

	ENDIF	;MAIN_PATCH

	
; end of the patch file
	PATCHFOOTER
; eof
